<?php

/*
  |--------------------------------------------------------------------------
  | Application & Route Filters
  |--------------------------------------------------------------------------
  |
  | Below you will find the "before" and "after" events for the application
  | which may be used to do any work before or after a request into your
  | application. Here you may also register your custom route filters.
  |
 */

App::before(function ($request) {
     
    // Share default setting for this application
    $loadQuiz = new Quiz();
    $users = User::where('user_level', '=', 0)->orderBy('id', 'desc')->get()->take(18);
    $get_quiz_group_id = $loadQuiz->getActiveQuizGroup(); // Get quiz group list

    View::share('settings', $loadQuiz->getPageSetting());
    View::share('users', $users);
    View::share('quiz_group', $get_quiz_group_id);
});

App::after(function ($request, $response) {
    //
});

/*
  |--------------------------------------------------------------------------
  | Authentication Filters
  |--------------------------------------------------------------------------
  |
  | The following filters are used to verify that the user of the current
  | session is logged into this application. The "basic" filter easily
  | integrates HTTP Basic authentication for quick, simple checking.
  |
 */
// Basic filter
Route::filter('auth.basic', function () {
    return Auth::basic();
});
// User route group filter
Route::filter('user', function ($route, $request) {
    /// If user level is admin .. page redirect to dashboard !
    if (Auth::user()->user_level == 1) {
        return Redirect::to('/admin');
    }
    /// If user level is user .. page redirect to quiz start page !
    if (Auth::user()->user_level != 0) {
        return Redirect::to('/');
    }
});
// Admin route group filter
Route::filter('admin', function ($route, $request) {
    if (Auth::user()->user_level != 1) {
        return Redirect::to('/admin-login');
    }
});

/*
  |--------------------------------------------------------------------------
  | Guest Filter
  |--------------------------------------------------------------------------
  |
  | The "guest" filter is the counterpart of the authentication filters as
  | it simply checks that the current user is not logged in. A redirect
  | response will be issued if they are, which you may freely change.
  |
 */

Route::filter('guest', function () {
    if (Auth::check()) {
        return Redirect::to('/');
    }
});

/*
  |--------------------------------------------------------------------------
  | CSRF Protection Filter
  |--------------------------------------------------------------------------
  |
  | The CSRF filter is responsible for protecting your application against
  | cross-site request forgery attacks. If this special token in a user
  | session does not match the one given in this request, we'll bail.
  |
 */

Route::filter('csrf', function () {
    if (Session::token() != Input::get('_token')) {
        throw new Illuminate\Session\TokenMismatchException();
    }
});

# When a user's session expires

Route::filter('auth', function () {
    if (!Auth::check()) {
        return Redirect::to('/');
    }
});


 // SSL 
Route::filter('ssl.force', function()
{
    if(App::environment('production') && !Request::secure())
    {
        // don't set a session cookie when redirecting to another scheme to 
        // avoid dropping the session when switching scheme
        Config::set('session.driver', 'array');
        // preserve query string while redirecting by using fullUrl()
        // instead of Redirect::secure + Request::path()
        $url = str_replace('http://', 'https://', Request::fullUrl());
        return Redirect::to($url, 302, array(), true);
    }

    // secure cookies for https
    Config::set('session.secure', Request::secure());
});


App::error(function(PDOException $exception)
{
    //Log::error("Error connecting to database: ".$exception->getMessage());
    return "Error connecting to database";
});